package org.q.app.contract.annotation;

import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import org.q.app.contract.ThreadPolicy;

/**
 * This annotation can be used to specify a Threading policy for a command to run in. By default all Q commands are
 * invoked in the swing event Thread.
 * 
 * @author Erik Lievaart
 */
@Retention(RetentionPolicy.RUNTIME)
@Inherited
public @interface Concurrency {

	/** The Thread policy for the command. */
	ThreadPolicy value();

}
