package org.q.app.engine.convert;

import java.util.List;

import org.q.app.engine.parse.ShellString;
import org.q.toolkit.convert.construct.AbstractConstructor;
import org.q.toolkit.lang.Str;
import org.q.toolkit.lang.collection.NewCollection;

class ListConstructor extends AbstractConstructor<List> {

	private final char splitter;

	public ListConstructor(final char splitter) {
		this.splitter = splitter;
	}

	@Override
	public List constructObject(final String str) {
		List<String> list = NewCollection.list();
		for (String item : Str.splitOnChar(str, splitter)) {
			list.add(ShellString.unescape(item.trim()));
		}
		return list;
	}

	@Override
	public Class<List> getLiteral() {
		return List.class;
	}
}
