package org.q.app.engine.impl;

import org.q.app.engine.context.UserVariables;
import org.q.app.engine.convert.PluginConvertersProvider;
import org.q.app.engine.impl.Engine.Core;
import org.q.app.engine.impl.Engine.Templated;
import org.q.app.engine.meta.MetadataCollection;
import org.q.app.general.ModuleBase;
import org.q.toolkit.convert.Converters;

import com.google.inject.Module;
import com.google.inject.Scopes;

/**
 * Guice module that configures the Engine.
 * 
 * @author Erik Lievaart
 */
public class EngineModule extends ModuleBase {

	private static final ModuleBase INSTANCE = new EngineModule();

	private EngineModule() {
	}

	@Override
	protected void configure() {
		bind(Converters.class).toProvider(new PluginConvertersProvider()).in(Scopes.SINGLETON);
		bindSingleton(Engine.class).annotatedWith(Templated.class).to(TemplateEngine.class);
		bindSingleton(Engine.class).annotatedWith(Core.class).to(QEngine.class);
		bindSingleton(UserVariables.class);
		bindSingleton(MetadataCollection.class);
	}

	/**
	 * Get the {@link Module}.
	 * 
	 * @return the {@link Module}.
	 */
	public static Module instance() {
		return INSTANCE;
	}

}
