package org.q.app.engine.impl;

import org.q.toolkit.lang.LogTemplate;

import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
class TemplateEngine implements Engine {
	private final LogTemplate log = new LogTemplate(getClass());

	@Inject
	private QEngine core;
	@Inject
	private EngineTemplates templates;
	@Inject
	private SafeOperations protection;

	@Override
	public void invoke(final String raw) {
		String processed = templates.apply(raw);
		log.info("Command: %", processed);

		if (protection.isAllowed(processed)) {
			core.invoke(processed);
		}
	}
}
