package org.q.app.engine.parse;

import java.util.EnumSet;

import org.q.toolkit.lang.concurrent.Immutable;

@Immutable
enum TokenType {
	RAW, SWALLOW, COMMAND, STRING, VARIABLE, BOOKMARK, UNRECOGNIZED, FLAG;

	private static final EnumSet<TokenType> ARGUMENT_TYPES = EnumSet.of(STRING, VARIABLE, BOOKMARK);

	boolean isArgument() {
		return ARGUMENT_TYPES.contains(this);
	}
}
