package org.q.app.ui.render;

import java.util.Collection;
import java.util.Vector;

public class BoundedVector<E> extends Vector<E> {

	private final int bound = 100;

	@Override
	public synchronized boolean add(final E e) {
		if (size() >= bound) {
			remove(0);
		}
		return super.add(e);
	}

	@Override
	public synchronized boolean addAll(final Collection<? extends E> c) {
		for (E e : c) {
			add(e);
		}
		return true;
	}
}
