package org.q.app.ui.render.icons;

import java.awt.Color;

import javax.swing.Icon;

abstract class QIcon implements Icon {
	private final int size;
	private final Color color;

	QIcon() {
		this(12);
	}

	QIcon(final int s) {
		this(s, Color.BLACK);
	}

	QIcon(final int s, final Color c) {
		size = s;
		color = c;
	}

	@Override
	public int getIconHeight() {
		return size;
	}

	@Override
	public int getIconWidth() {
		return size;
	}

	/**
	 * Get the color in which the Icon will be drawn.
	 */
	public Color getColor() {
		return color;
	}
}
