package org.q.app.ui.render.terminal;

import org.q.app.general.DetailMessage;
import org.q.toolkit.runtime.CommandOutput;

import com.google.inject.Inject;

/**
 * Writes error messages from native the command line to the terminal using a Beanshell script.
 * 
 * @author Erik Lievaart
 */
public class TerminalError implements CommandOutput {

	// Why the heck does checkstyle (5.1 or 5.3) enforce that this variable is final while TerminalOutput is fine?
	private final TerminalScript script;

	@Inject
	private TerminalError(final TerminalScript script) {
		this.script = script;
	}

	@Override
	public void println(final String msg) {
		script.addMessage(DetailMessage.error(msg));
	}

}