package org.q.plugins.find;

import java.util.Hashtable;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;

import org.q.app.config.ResourcePaths;
import org.q.app.engine.script.ScriptConfig;
import org.q.app.engine.script.ScriptInvocation;
import org.q.app.engine.script.SwingScript;
import org.q.app.vfs.VirtualFile;

import com.google.inject.Inject;

class IncrementalFind implements Observer {

	private VirtualFile dir;

	@Inject
	private SwingScript script;

	public void setDir(final VirtualFile dir) {
		this.dir = dir;
	}

	@Override
	public void update(final Observable o, final Object arg) {
		Map<String, Object> properties = new Hashtable<String, Object>();
		properties.put("dir", dir);
		properties.put("match", arg);

		script.invoke(new ScriptConfig(properties), new ScriptInvocation(ResourcePaths.FIND_INCREMENTAL_SCRIPT));
	}

}
