package org.q.toolkit.reflect.annotations;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;

import org.q.toolkit.lang.concurrent.Immutable;
import org.q.toolkit.reflect.InstanceTool;
import org.q.toolkit.reflect.method.MethodWrapper;

/**
 * Wrapper for a Method that has an Annotation.
 * 
 * @param <A>
 *            type of the annotation.
 * 
 * @author Erik Lievaart
 */
@Immutable
public class AnnotatedMethod<A extends Annotation> extends AnnotatedMember<Method, A> {

	AnnotatedMethod(final Method method, final A annotation) {
		super(method, annotation);
	}

	/**
	 * Get a MethodWrapper for the annotated Method on the specified Object.
	 */
	public MethodWrapper getMethodWrapper(final Object instance) {
		return InstanceTool.getMethodWrapper(getName(), instance);
	}

}
